/* Sun-1.1 */

/* Copyright 1992 Sun Microsystems, Inc. and Stanford University.
   See the LICENSE file for license information. */

# pragma interface

# ifdef XLIB
  
# define xTypeSealsDo(template)						      \
    template(Display)							      \
    template(Window)							      \
    template(Drawable)							      \
    template(Cursor)							      \
    template(GC)							      \
    template(XGCValues)							      \
    template(Pixmap)							      \
    template(Visual)							      \
    template(Colormap)							      \
    template(XColor)							      \
    template(Screen)							      \
    template(XEvent)							      \
    template(XButtonEvent)						      \
    template(XKeyEvent)							      \
    template(XExposeEvent)						      \
    template(XMotionEvent)						      \
    template(XConfigureEvent)						      \
    template(XClientMessageEvent)					      \
    template(XVisibilityEvent)						      \
    template(XCrossingEvent)						      \
    template(XMapEvent)							      \
    template(XUnmapEvent)						      \
    template(XColormapEvent)						      \
    template(XReparentEvent)						      \
    template(XAnyEvent)							      \
    template(XSizeHints)						      \
    template(XEnterWindowEvent)						      \
    template(XLeaveWindowEvent)						      \
    template(XWMHints)							      \
    template(XTextProperty)						      \
    template(XTextProperty_value)					      \
    template(Atom) 

# define declareXTypeSeals(stem)					      \
    extern char* CONC(stem,_seal);

# define defineXTypeSeals(stem)						      \
    char* CONC(stem,_seal) = STR(stem);

xTypeSealsDo(declareXTypeSeals)


# define XEvent_member_wraps_Do(template)				      \
    template(XAnyEvent,xany)						      \
    template(XButtonEvent,xbutton)					      \
    template(XCirculateEvent,xcirculate)				      \
    template(XCirculateRequestEvent,xcirculaterequest)			      \
    template(XClientMessageEvent,xclient)				      \
    template(XColormapEvent,xcolormap)					      \
    template(XConfigureEvent,xconfigure)				      \
    template(XConfigureRequestEvent,xconfigurerequest)			      \
    template(XCreateWindowEvent,xcreatewindow)				      \
    template(XCrossingEvent,xcrossing)					      \
    template(XDestroyWindowEvent,xdestroywindow)			      \
    template(XErrorEvent,xerror)					      \
    template(XExposeEvent,xexpose)					      \
    template(XFocusChangeEvent,xfocus)					      \
    template(XGraphicsExposeEvent,xgraphicsexpose)			      \
    template(XGravityEvent,xgravity)					      \
    template(XKeyEvent,xkey)						      \
    template(XKeymapEvent,xkeymap)					      \
    template(XMapEvent,xmap)						      \
    template(XMapRequestEvent,xmaprequest)				      \
    template(XMappingEvent,xmapping)					      \
    template(XMotionEvent,xmotion)					      \
    template(XNoExposeEvent,xnoexpose)					      \
    template(XPropertyEvent,xproperty)					      \
    template(XReparentEvent,xreparent)					      \
    template(XResizeRequestEvent,xresizerequest)			      \
    template(XSelectionClearEvent,xselectionclear)			      \
    template(XSelectionEvent,xselection)				      \
    template(XSelectionRequestEvent,xselectionrequest)			      \
    template(XUnmapEvent,xunmap)					      \
    template(XVisibilityEvent,xvisibility)


# define declare_XEvent_member_wrap(type,member)			      \
    type* CONC3(get_,member,_wrap) (XEvent*);				      

# define define_XEvent_member_wrap(type,member)				      \
    type* CONC3(get_,member,_wrap) (XEvent* e) {return & e->member;}

XEvent_member_wraps_Do(declare_XEvent_member_wrap)


  Display*  XOpenDisplay_wrap(   char*,    void*);
  void      XCloseDisplay_wrap(  Display*  display);
  int       XSetWMProtocol_wrap( Display*, Window, Atom);

  void XQueryColors_wrap( Display*, Colormap, objVectorOop, void*);	       
  void XStoreColors_wrap( Display*, Colormap, objVectorOop, void*);	 

  Atom XClientMessageEvent_atomAt_wrap(XClientMessageEvent*,
                                       unsigned int        ,
                                       void*               );

  int XStringToTextProperty_wrap(XTextProperty*, char*);

  inline void XFree_XSizeHints_wrap(XSizeHints *p) {XFree((char*)p);}
  inline void XFree_XWMHints_wrap  (XWMHints   *p) {XFree((char*)p);}

  inline XEvent* asXEvent(XEvent* e) {return e;}


# define   WHAT_GLUE PROTOTYPES
  xlib_glue
# undef WHAT_GLUE
# endif
