"Sun-1.4"

"Copyright 1992 Sun Microsystems, Inc. and Stanford University.
 See the LICENSE file for license information."

"CAUTION: This file is not part of the documented Self world.  It may be
 be changed or removed at any time, and it will not be documented.
 This file can be removed without affecting the Self world in any way."


"Template used by primitiveMaker to create Xlib primitives."


primitiveMaker reader copy dynamicLinking create: 'xlib' From: ('

  -- Copyright 1992 Sun Microsystems, Inc. and Stanford University.
  -- See the LICENSE file for license information.

  macroName: xlib
  glueLibraryName: xlib_glue.so


','


traits: traits xlib display raw
  -- display
  // XOpenDisplay and XCloseDisplay are (statically) defined in the VM
  ^ void xDisplayName: string = string call XDisplayName canAWS
  _ Display defaultScreenOfDisplay \
	    = Screen {xlib screen deadCopy} call DefaultScreenOfDisplay 
  _ Display connectionNumber = int call ConnectionNumber


  -- visual info 
  ^ Display xMatchVisualInfoScreen: int Depth: int Class: int \
    	    = XVisualInfo {xlib xVisualInfo deadCopy} \
	      call XMatchVisualInfo_wrap passFailHandle canAWS


  -- event handling
  ^ Display xEventsQueued: int     = int  call XEventsQueued canAWS
  ^ Display xPending		   = int  call XPending      canAWS
  ^ Display xNextEventInto: XEvent = void call XNextEvent    canAWS
  ^ Display xPeekEventInto: XEvent = void call XPeekEvent    canAWS
  ^ Display xPutBackEvent: XEvent  = void call XPutBackEvent canAWS

  ^ Display xCheckType: int  OfEvent: XEvent = bool call XCheckTypedEvent canAWS
  ^ Display xCheckMask: long OfEvent: XEvent = bool call XCheckMaskEvent  canAWS


  -- synchronization
  ^ Display xFlush                  = void call XFlush       canAWS
  ^ Display xSynchronize: bool      = void call XSynchronize canAWS
  ^ Display xSyncDiscardingIf: bool = void call XSync	     canAWS


  -- gc
  // the following uses ANY_SEAL because drawables can be pixmaps or windows
  // since pixmaps and windows are integers, this will not cause a crash
  ^ Display xCreateGCDrawable: proxy Drawable ANY_SEAL \
                    ValueMask: unsigned_long \
                       Values: XGCValues \
            = proxy GC GC_seal {xlib graphicsContext deadCopy} \
              call XCreateGC canAWS
  ^ Display xFreeGC: proxy GC GC_seal = void call XFreeGC canAWS

  ^ Display xGetGCValuesGC: proxy GC GC_seal \
		 ValueMask: unsigned_long \
		    Values: XGCValues \
    	    = void call XGetGCValues_wrap passFailHandle canAWS

  ^ Display xSetGC: proxy GC GC_seal Foreground: unsigned_long \
            = void call XSetForeground canAWS
  ^ Display xSetGC: proxy GC GC_seal Background: unsigned_long \
            = void call XSetBackground canAWS
  ^ Display xSetGC: proxy GC GC_seal Function: int \
            = void call XSetFunction canAWS
  ^ Display xSetGC: proxy GC GC_seal PlaneMask: unsigned_long \
            = void call XSetPlaneMask canAWS
  ^ Display xSetGC: proxy GC GC_seal LineAttributesWidth: unsigned_int \
					       LineStyle: int \
					        CapStyle: int \
					       JoinStyle: int \
            = void call XSetLineAttributes canAWS
  ^ Display xSetGC: proxy GC GC_seal Font: proxy Font Font_seal \
            = void call XSetFont canAWS
  ^ Display xSetGC: proxy GC GC_seal GraphicsExposures: bool \
            = void call XSetGraphicsExposures canAWS
  ^ Display xSetGC: proxy GC GC_seal FillStyle: int \
	    = void call XSetFillStyle canAWS
  ^ Display xSetGC: proxy GC GC_seal FillRule: int \
	    = void call XSetFillRule canAWS
  ^ Display xSetGC: proxy GC GC_seal Stipple: proxy Pixmap Pixmap_seal \
	    = void call XSetStipple canAWS

  ^ Display xQueryBestStippleWidth: proxy Drawable ANY_SEAL \
			     Width: int \
			    Height: int \
	    = unsigned_long call XQueryBestStippleWidth passFailHandle canAWS
  ^ Display xQueryBestStippleHeight: proxy Drawable ANY_SEAL \
			      Width: int \
			     Height: int \
	    = unsigned_long call XQueryBestStippleWidth passFailHandle canAWS


  -- atom
  _ Display xInternAtom: string OnlyIfExists: bool \
            = proxy Atom Atom_seal {xlib atom deadCopy} call XInternAtom canAWS


  -- window
  ^ Display xCreateSimpleWindowIn: proxy Window Window_seal \
                                X: int \
                                Y: int \
                            Width: unsigned_int \
                           Height: unsigned_int \
                      BorderWidth: unsigned_int \
                           Border: unsigned_long \
                       Background: unsigned_long \
            = proxy Window Window_seal {xlib window deadCopy} \
	      call XCreateSimpleWindow canAWS

  ^ Display xSetWMProtocolOfWindow: proxy Window Window_seal \
		          Protocol: proxy Atom Atom_seal \
	 = int call XSetWMProtocol_wrap canAWS
  ^ Display xSetWMNameOfWindow: proxy Window Window_seal To: XTextProperty \
            = void call XSetWMName canAWS
  ^ Display xSetWMIconNameOfWindow: proxy Window Window_seal To: XTextProperty \
            = void call XSetWMIconName canAWS
  ^ Display xSetWMHintsOfWindow: proxy Window Window_seal To: XWMHints \
            = void call XSetWMHints canAWS
  ^ Display xSetWMNormalHintsOfWindow: proxy Window Window_seal To: XSizeHints \
            = void call XSetWMNormalHints canAWS

  ^ Display xSelectInputOfWindow: proxy Window Window_seal EventMask: long \
            = void call XSelectInput canAWS

  ^ Display xMapWindow: proxy Window Window_seal = void call XMapWindow canAWS
  ^ Display xRaiseWindow: proxy Window Window_seal \
            = void call XRaiseWindow canAWS

  ^ Display xUnmapWindow: proxy Window Window_seal = void call XUnmapWindow canAWS
  ^ Display xDestroyWindow: proxy Window Window_seal = void call XDestroyWindow canAWS
  ^ Display xMoveResizeWindow: proxy Window Window_seal \
			    X: int \
			    Y: int \
			Width: unsigned_int \
			Height: unsigned_int \
	= void call XMoveResizeWindow


  -- cursor
  ^ Display xWarpPointerSrcWindow: proxy_null Window Window_seal \
                       DestWindow: proxy_null Window Window_seal \
                             SrcX: int \
                             SrcY: int \
                         SrcWidth: unsigned_int \
                        SrcHeight: unsigned_int \
                            DestX: int \
                            DestY: int \
            = void call XWarpPointer canAWS

  ^ Display xGrabPointerWindow: proxy Window Window_seal \
                   OwnerEvents: bool \
                     EventMask: unsigned_int \
                   PointerMode: int \
                  KeyboardMode: int \
                     ConfineTo: proxy_null Window Window_seal \
                        Cursor: proxy_null Cursor Cursor_seal \
                          Time: unsigned_long \
            = int call XGrabPointer  canAWS                        
  ^ Display xUngrabPointerTime: unsigned_long = void call XUngrabPointer canAWS

  ^ Display xDefineCursorWindow: proxy      Window Window_seal \
                         Cursor: proxy_null Cursor Cursor_seal \
            = void call XDefineCursor canAWS
  ^ Display xUndefineCursorWindow: proxy Window Window_seal \
            = void call XUndefineCursor canAWS

  ^ Display xCreatePixmapCursorSource: proxy      Pixmap Pixmap_seal \
                                 Mask: proxy_null Pixmap Pixmap_seal \
                      ForegroundColor: XColor \
                      BackgroundColor: XColor \
                                    X: unsigned_int \
                                    Y: unsigned_int \
            = proxy Cursor Cursor_seal {xlib cursor deadCopy} \
              call XCreatePixmapCursor canAWS
  ^ Display xFreeCursor: proxy Cursor Cursor_seal = void call XFreeCursor canAWS


  -- colormap
  ^ Display xCreateColormapWindow: proxy Window Window_seal \
                           Visual: Visual \
                         Allocate: bool \
            = proxy Colormap Colormap_seal {xlib colormap deadCopy} \
              call XCreateColormap canAWS
  ^ Display xFreeColormap: proxy Colormap Colormap_seal \
            = void call XFreeColormap canAWS

  ^ Display xSetWindow: proxy Window Window_seal \
              Colormap: proxy Colormap Colormap_seal \
            = void call XSetWindowColormap canAWS

  ^ Display xQueryColormap: proxy Colormap Colormap_seal \
                    Colors: oop objVector \
            = void call XQueryColors_wrap passFailHandle canAWS
  ^ Display xStoreColormap: proxy Colormap Colormap_seal \
                    Colors: oop objVector \
            = void call XStoreColors_wrap passFailHandle canAWS
  ^ Display xQueryColormap: proxy Colormap Colormap_seal Color: XColor \
            = void call XQueryColor canAWS
  ^ Display xStoreColormap: proxy Colormap Colormap_seal Color: XColor \
            = void call XStoreColor canAWS


  -- pixmap
  // the following uses ANY_SEAL because drawables can be pixmaps or windows
  // since pixmaps and windows are integers, this will not cause a crash
  ^ Display xCreateBitmapDrawable: proxy Drawable ANY_SEAL \
                             Data: cbv char* \
                            Width: unsigned_int \
                           Height: unsigned_int \
            = proxy Pixmap Pixmap_seal {xlib pixmap deadCopy} \
	      call XCreateBitmapFromData canAWS

  // the following uses ANY_SEAL because drawables can be pixmaps or windows
  // since pixmaps and windows are integers, this will not cause a crash
  ^ Display xCreatePixmap: proxy Drawable ANY_SEAL \
    	    	    Width: unsigned_int \
		   Height: unsigned_int \
		    Depth: unsigned_int \
    	    = proxy Pixmap Pixmap_seal {xlib pixmap deadCopy} \
	      call XCreatePixmap canAWS
  ^ Display xFreePixmap: proxy Pixmap Pixmap_seal \
            = void call XFreePixmap canAWS

','

  -- drawing
  // the following uses ANY_SEAL because drawables can be pixmaps or windows
  // since pixmaps and windows are integers, this will not cause a crash

  ^ Display xClearWindow: proxy Window Window_seal \
    	    = void call XClearWindow canAWS

  ^ Display xCopyAreaSrc: proxy Drawable ANY_SEAL \
		    Dest: proxy Drawable ANY_SEAL \
		      GC: proxy GC GC_seal \
		    SrcX: int \
		    SrcY: int \
		   Width: unsigned_int \
		  Height: unsigned_int \
		   DestX: int \
		   DestY: int \
    	    = void call XCopyArea canAWS

  ^ Display copyBitmap: proxy Drawable ANY_SEAL \
		    Dest: proxy Drawable ANY_SEAL \
		      GC: proxy GC GC_seal \
		   Width: unsigned_int \
		  Height: unsigned_int \
		   DestX: int \
		   DestY: int \
    	    = void call kjx_copyBitmap canAWS

  ^ Display xDrawPoint: proxy Drawable ANY_SEAL \
		    GC: proxy GC GC_seal \
		     X: int \
		     Y: int \
    	    = void call XDrawPoint canAWS
  ^ Display xDrawLine: proxy Drawable ANY_SEAL \
		   GC: proxy GC GC_seal \
		   X1: int \
		   Y1: int \
		   X2: int \
		   Y2: int \
	    = void call XDrawLine canAWS
  ^ Display xDrawRectangle: proxy Drawable ANY_SEAL \
			GC: proxy GC GC_seal \
			 X: int \
			 Y: int \
		     Width: unsigned_int \
		    Height: unsigned_int \
    	    = void call XDrawRectangle canAWS
  ^ Display xFillRectangle: proxy Drawable ANY_SEAL \
			GC: proxy GC GC_seal \
			 X: int \
			 Y: int \
		     Width: unsigned_int \
		    Height: unsigned_int \
    	    = void call XFillRectangle canAWS
  ^ Display xFillPolygon: proxy Drawable ANY_SEAL \
		      GC: proxy GC GC_seal \
		      Xs: oop objVector \
		      Ys: oop objVector \
		   Shape: int \
		    Mode: int \
    	    = void call XFillPolygon_wrap passFailHandle canAWS
  ^ Display xDrawArc: proxy Drawable ANY_SEAL \
    	       	  GC: proxy GC GC_seal \
		   X: int \
		   Y: int \
	       Width: unsigned_int \
	      Height: unsigned_int \
	  StartAngle: int \
	    EndAngle: int \
    	    = void call XDrawArc canAWS
  ^ Display xFillArc: proxy Drawable ANY_SEAL \
    	       	  GC: proxy GC GC_seal \
		   X: int \
		   Y: int \
	       Width: unsigned_int \
	      Height: unsigned_int \
	  StartAngle: int \
	    EndAngle: int \
    	    = void call XFillArc canAWS
  ^ Display xDrawString: proxy Drawable ANY_SEAL \
		     GC: proxy GC GC_seal \
		      X: int \
		      Y: int \
		 String: string_len_null \
	    = void call XDrawString canAWS


  -- font
  ^ Display xQueryFont: proxy Font Font_seal \
    	    = XFontStruct {xlib xFontStruct deadCopy} \
	      call XQueryFont canAWS
  ^ Display xLoadQueryFont: string_null \
    	    = XFontStruct {xlib xFontStruct deadCopy} \
	      call XLoadQueryFont_wrap passFailHandle canAWS
  ^ Display xFreeFont: XFontStruct = void call XFreeFont canAWS


  -- image
  ^ Display xGetImage: proxy Drawable ANY_SEAL \
		    X: int \
		    Y: int \
		Width: unsigned_int \
	       Height: unsigned_int \
	    PlaneMask: unsigned_long \
	       Format: int \
    	    = XImage {xlib xImage deadCopy} call XGetImage canAWS
','



traits: traits xlib window raw
  ^ void nullWindow \
    	    = proxy_null Window Window_seal {xlib window deadCopy} get NULL 



traits: traits xlib cursor raw
  ^ void nullCursor \
    	    = proxy_null Cursor Cursor_seal {xlib cursor deadCopy} get NULL 



traits: traits xlib screen raw
  ^ Screen rootWindowOfScreen \
            = proxy Window Window_seal {xlib window deadCopy} \
	      call RootWindowOfScreen
  ^ Screen defaultVisualOfScreen \
            = Visual {xlib visual deadCopy} call DefaultVisualOfScreen
  ^ Screen defaultGCOfScreen \
            = proxy GC GC_seal {xlib graphicsContext deadCopy} \
	      call DefaultGCOfScreen
  ^ Screen defaultColormapOfScreen \
	    = proxy Colormap Colormap_seal {xlib colormap deadCopy} \
	      call DefaultColormapOfScreen

  ^ Screen blackPixelOfScreen = unsigned_long call BlackPixelOfScreen
  ^ Screen whitePixelOfScreen = unsigned_long call WhitePixelOfScreen

  ^ Screen widthOfScreen  = int call WidthOfScreen
  ^ Screen heightOfScreen = int call HeightOfScreen
  ^ Screen defaultDepthOfScreen = int call DefaultDepthOfScreen

  ^ Screen xScreenNumberOfScreen = int call XScreenNumberOfScreen canAWS



traits: traits xlib xVisualInfo raw
  ^ void new = XVisualInfo {xlib xVisualInfo deadCopy} new
  ^ XVisualInfo delete = void delete



traits: traits xlib xFontStruct raw
  ^ XFontStruct xTextWidth: string_len_null = int call XTextWidth canAWS
  ^ XFontStruct fid     = proxy Font Font_seal {xlib font deadCopy} \
			  getMember fid
  ^ XFontStruct ascent  = int getMember ascent
  ^ XFontStruct descent = int getMember descent

  ^ XFontStruct maxCharWidth  = int call maxCharWidth
  ^ XFontStruct maxCharHeight = int call maxCharHeight



traits: traits xlib xCharStruct raw
  ^ XCharStruct width   = int getMember width
  ^ XCharStruct ascent  = int getMember ascent
  ^ XCharStruct descent = int getMember descent



traits: traits xlib xGCValues raw
  ^ void new = XGCValues {xlib xGCValues deadCopy} new
  ^ XGCValues delete = void delete

  ^ XGCValues function      	 = int getMember function
  ^ XGCValues plane_mask	 = unsigned_long getMember plane_mask
  ^ XGCValues foreground	 = unsigned_long getMember foreground
  ^ XGCValues background	 = unsigned_long getMember background
  ^ XGCValues line_width	 = int getMember line_width
  ^ XGCValues fill_style	 = int getMember fill_style
  ^ XGCValues fill_rule		 = int getMember fill_rule
  ^ XGCValues graphics_exposures = bool getMember graphics_exposures
  ^ XGCValues font		 = proxy Font Font_seal {xlib font deadCopy} \
				   getMember font
  ^ XGCValues stipple = proxy Pixmap Pixmap_seal {xlib pixmap deadCopy } \
			getMember stipple



traits: traits xlib xColor raw
  ^ void new = XColor {xlib xColor deadCopy} new
  ^ XColor delete = void delete

  ^ XColor pixel = int  getMember pixel
  ^ XColor red   = int  getMember red
  ^ XColor green = int  getMember green
  ^ XColor blue  = int  getMember blue
  ^ XColor flags = char getMember flags

  ^ XColor pixel: int  = void setMember pixel
  ^ XColor red:   int  = void setMember red
  ^ XColor green: int  = void setMember green
  ^ XColor blue:  int  = void setMember blue
  ^ XColor flags: char = void setMember flags



traits: traits xlib xImage raw
  ^ XImage xGetPixelX: int Y: int = unsigned_long call XGetPixel canAWS

', '


traits: traits xlib events xEvent raw
  ^ void new = XEvent {xlib events xEvent deadCopy} new
  _ XEvent basicDelete = void delete
  ^ XEvent type = int getMember type

  // this next one is an unfortunate type-safety hole -- dmu
  ^ proxy XEvent* ANY_SEAL asXEvent \
        = XEvent {xlib events xEvent deadCopy} call asXEvent

  ^ XEvent       xany      = \
                 XAnyEvent \
    {xlib events xAnyEvent deadCopy} \
        call get_xany_wrap

  ^ XEvent       xbutton   = \
                 XButtonEvent \
    {xlib events xButtonEvent deadCopy} \
        call get_xbutton_wrap
  
  ^ XEvent       xclient   = \
                 XClientMessageEvent   \
    {xlib events xClientMessageEvent deadCopy} \
        call get_xclient_wrap

  ^ XEvent       xcolormap = \
                 XColormapEvent \
    {xlib events xColormapEvent deadCopy} \
        call get_xcolormap_wrap

  ^ XEvent       xconfigure = \
                 XConfigureEvent \
    {xlib events xConfigureEvent deadCopy} \
        call get_xconfigure_wrap

  ^ XEvent       xcrossing  = \
                 XCrossingEvent \
    {xlib events xCrossingEvent deadCopy} \
        call get_xcrossing_wrap

  ^ XEvent       xexpose  = \
                 XExposeEvent \
    {xlib events xExposeEvent deadCopy} \
        call get_xexpose_wrap

  ^ XEvent       xgraphicsexpose  = \
                 XGraphicsExposeEvent \
    {xlib events xGraphicsExposeEvent deadCopy} \
        call get_xgraphicsexpose_wrap

  ^ XEvent       xkey  = \
                 XKeyEvent \
    {xlib events xKeyEvent deadCopy} \
        call get_xkey_wrap

  ^ XEvent       xmap  = \
                 XMapEvent \
    {xlib events xMapEvent deadCopy} \
        call get_xmap_wrap

  ^ XEvent       xmotion  = \
                 XMotionEvent \
    {xlib events xMotionEvent deadCopy} \
        call get_xmotion_wrap

  ^ XEvent       xnoexpose  = \
                 XNoExposeEvent \
    {xlib events xNoExposeEvent deadCopy} \
        call get_xnoexpose_wrap

  ^ XEvent       xreparent  = \
                 XReparentEvent \
    {xlib events xReparentEvent deadCopy} \
        call get_xreparent_wrap

  ^ XEvent       xunmap  = \
                 XUnmapEvent \
    {xlib events xUnmapEvent deadCopy} \
        call get_xunmap_wrap

  ^ XEvent       xvisibility  = \
                 XVisibilityEvent \
    {xlib events xVisibilityEvent deadCopy} \
        call get_xvisibility_wrap



traits: traits xlib events xButtonEvent raw
  ^ XButtonEvent x      = int getMember x
  ^ XButtonEvent y      = int getMember y
  ^ XButtonEvent x_root = int getMember x_root
  ^ XButtonEvent y_root = int getMember y_root
  ^ XButtonEvent state  = unsigned_int getMember state
  ^ XButtonEvent button = unsigned_int getMember button
  ^ XButtonEvent window = proxy Window Window_seal {xlib window deadCopy} \
                          getMember window



traits: traits xlib events xClientMessageEvent raw
  ^ XClientMessageEvent message_type \
        = proxy Atom Atom_seal {xlib atom deadCopy} getMember message_type
  ^ XClientMessageEvent format = int getMember format
  ^ XClientMessageEvent atomAt: unsigned_int \
        = proxy Atom Atom_seal {xlib atom deadCopy} \
	  call XClientMessageEvent_atomAt_wrap passFailHandle
  ^ XClientMessageEvent window \
	= proxy Window Window_seal {xlib window deadCopy} getMember window



traits: traits xlib events xColormapEvent raw
  ^ XColormapEvent c_new   = bool getMember c_new
  ^ XColormapEvent state   = unsigned_int getMember state
  ^ XColormapEvent window  = proxy Window Window_seal {xlib window deadCopy} \
                             getMember window



traits: traits xlib events xConfigureEvent raw
  ^ XConfigureEvent x      = int getMember x
  ^ XConfigureEvent y      = int getMember y
  ^ XConfigureEvent width  = int getMember width 
  ^ XConfigureEvent height = int getMember height
  ^ XConfigureEvent window = proxy Window Window_seal {xlib window deadCopy} \
                             getMember window



traits: traits xlib events xCrossingEvent raw
  ^ XCrossingEvent window = proxy Window Window_seal {xlib window deadCopy} \
                            getMember window
  ^ XCrossingEvent x      = int getMember x
  ^ XCrossingEvent y      = int getMember y


traits: traits xlib events xExposeEvent raw
  ^ XExposeEvent x      = int getMember x
  ^ XExposeEvent y      = int getMember y
  ^ XExposeEvent width  = int getMember width 
  ^ XExposeEvent height = int getMember height
  ^ XExposeEvent count  = int getMember count
  ^ XExposeEvent window = proxy Window Window_seal {xlib window deadCopy} \
                          getMember window



traits: traits xlib events xGraphicsExposeEvent raw
  ^ XGraphicsExposeEvent x      = int getMember x
  ^ XGraphicsExposeEvent y      = int getMember y
  ^ XGraphicsExposeEvent width  = int getMember width 
  ^ XGraphicsExposeEvent height = int getMember height
  ^ XGraphicsExposeEvent count  = int getMember count
  // the next can return either a pixmap or a window (ie, any drawable).
  // current glue cannot handle this kind of thing.  to get at this member, you
  // will need to write a C wrapper that will return the right kind of proxy.
  // ^ XGraphicsExposeEvent drawable \
  //   	    = proxy Window Window_seal {xlib window deadCopy} getMember drawable



traits: traits xlib events xKeyEvent raw
  ^ XKeyEvent x       = int getMember x
  ^ XKeyEvent y       = int getMember y
  ^ XKeyEvent x_root  = int getMember x_root
  ^ XKeyEvent y_root  = int getMember y_root
  ^ XKeyEvent state   = unsigned_int getMember state
  ^ XKeyEvent keycode = unsigned_int getMember keycode
  ^ XKeyEvent window  = proxy Window Window_seal {xlib window deadCopy} \
                        getMember window
  ^ XKeyEvent xLookupStringReturn: bv_len char* \
    	    = int call XLookupString_wrap canAWS



traits: traits xlib events xMapEvent raw
  ^ XMapEvent window = proxy Window Window_seal {xlib window deadCopy} \
		       getMember window



traits: traits xlib events xMotionEvent raw
  ^ XMotionEvent x       = int getMember x
  ^ XMotionEvent y       = int getMember y
  ^ XMotionEvent x_root  = int getMember x_root
  ^ XMotionEvent y_root  = int getMember y_root
  ^ XMotionEvent state   = unsigned_int getMember state
  ^ XMotionEvent is_hint = char getMember is_hint
  ^ XMotionEvent window  = proxy Window Window_seal {xlib window deadCopy} \
                           getMember window



traits: traits xlib events xNoExposeEvent raw
  // the next can return either a pixmap or a window (ie, any drawable).
  // current glue cannot handle this kind of thing.  to get at this member, you
  // will need to write a C wrapper that will return the right kind of proxy.
  // ^ XNoExposeEvent drawable
  //        = proxy Window Window_seal {xlib window deadCopy} getMember drawable



traits: traits xlib events xReparentEvent raw
  ^ XReparentEvent x      = int getMember x
  ^ XReparentEvent y      = int getMember y
  ^ XReparentEvent window = proxy Window Window_seal {xlib window deadCopy} \
			    getMember window
  ^ XReparentEvent parent_window \
    	    = proxy Window Window_seal {xlib window deadCopy} getMember parent



traits: traits xlib events xUnmapEvent raw
  ^ XUnmapEvent window = proxy Window Window_seal {xlib window deadCopy} \
                         getMember window



traits: traits xlib events xVisibilityEvent raw
  ^ XVisibilityEvent state  = unsigned_int getMember state
  ^ XVisibilityEvent window = proxy Window Window_seal {xlib window deadCopy} \
                              getMember window


', '


traits: traits xlib xSizeHints raw
  ^ void new = XSizeHints {xlib xSizeHints deadCopy} call XAllocSizeHints
  ^ XSizeHints delete = void call XFree_XSizeHints_wrap canAWS

  ^ XSizeHints flags = long getMember flags

  ^ XSizeHints min_width  = int getMember min_width
  ^ XSizeHints min_height = int getMember min_height
  ^ XSizeHints max_width  = int getMember max_width
  ^ XSizeHints max_height = int getMember max_height

  ^ XSizeHints flags: long = void setMember flags

  ^ XSizeHints min_width:  int = void setMember min_width
  ^ XSizeHints min_height: int = void setMember min_height
  ^ XSizeHints max_width:  int = void setMember max_width
  ^ XSizeHints max_height: int = void setMember max_height



traits: traits xlib xWMHints raw
  ^ void new = XWMHints {xlib xWMHints deadCopy} call XAllocWMHints      
  ^ XWMHints delete = void call XFree_XWMHints_wrap canAWS

  ^ XWMHints flags         = long getMember flags
  ^ XWMHints input         = bool getMember input
  ^ XWMHints initial_state = int getMember initial_state
  ^ XWMHints icon_x        = int getMember icon_x
  ^ XWMHints icon_y        = int getMember icon_y
  ^ XWMHints icon_pixmap   = proxy Pixmap Pixmap_seal {xlib pixmap deadCopy} \
                             getMember icon_pixmap
  ^ XWMHints icon_window   = proxy Window Window_seal {xlib window deadCopy} \
                             getMember icon_window
  ^ XWMHints icon_mask     = proxy Pixmap Pixmap_seal {xlib pixmap deadCopy} \
                             getMember icon_mask

  ^ XWMHints flags: long        = void setMember flags
  ^ XWMHints input: bool	= void setMember input
  ^ XWMHints initial_state: int = void setMember initial_state
  ^ XWMHints icon_x: int        = void setMember icon_x
  ^ XWMHints icon_y: int	= void setMember icon_y
  ^ XWMHints icon_pixmap: proxy Pixmap Pixmap_seal = void setMember icon_pixmap
  ^ XWMHints icon_window: proxy Window Window_seal = void setMember icon_window
  ^ XWMHints icon_mask:   proxy Pixmap Pixmap_seal = void setMember icon_mask



traits: traits xlib xTextProperty raw
  ^ void new = XTextProperty {xlib xTextProperty deadCopy} new
  _ void freeValue: proxy {char*} XTextProperty_value_seal = void call XFree 
  _ XTextProperty basicDelete = void delete
  _ XTextProperty value \
    	    = proxy {unsigned char*} XTextProperty_value_seal {proxy deadCopy} \
	      getMember value
  ^ XTextProperty xStringToTextProperty: string \
    	    = int call XStringToTextProperty_wrap canAWS

traits: traits xlib window raw
  ^ Window getWinId = unsigned_long call kjx_getWinId canAWS



')

